Minor updates and fixes to rc template.

This commit is contained in:
Darren 'Tadgy' Austin 2022-08-24 00:47:35 +01:00
commit 1da710fccb

View file

@ -14,10 +14,10 @@ PIDFILE=""
# EXTRA_ARGS=() # Extra arguments passed to $EXEC. Must be an array. # EXTRA_ARGS=() # Extra arguments passed to $EXEC. Must be an array.
# SLAY_DELAY="" # Delay between the SIGTERM and SIGKILL on a 'stop'. Default: 2s. # SLAY_DELAY="" # Delay between the SIGTERM and SIGKILL on a 'stop'. Default: 2s.
# RESTART_DELAY="" # Delay between stopping and starting on a 'restart'. Default: 2s. # RESTART_DELAY="" # Delay between stopping and starting on a 'restart'. Default: 2s.
[[ -e "/etc/default/${0##*rc.}" ]] && source "/etc/default/${0##*rc.}" [[ -e "/etc/default/${0##*rc.}" ]] && { source "/etc/default/${0##*rc.}" || return 1 2>/dev/null || exit 1; }
error() { error() {
printf "%s: %s: %s\\n" "${BASH_SOURCE##*/}" "${EXEC##*/}" "$*" >&2 printf "%s: %s: %s\\n" "${BASH_SOURCE[0]##*/}" "${EXEC##*/}" "$*" >&2
} }
checkconfigured() { checkconfigured() {
@ -31,17 +31,17 @@ checkconfigured() {
checkstatus() { checkstatus() {
local RUNPIDS="$({ pgrep -f "$EXEC"; pgrep -F "$PIDFILE" 2>/dev/null; } | sort -u )" local RUNPIDS="$({ pgrep -f "$EXEC"; pgrep -F "$PIDFILE" 2>/dev/null; } | sort -u )"
if [[ ! -z "$RUNPIDS" ]]; then if [[ ! -z "$RUNPIDS" ]]; then
printf "%s: %s: %s" "${BASH_SOURCE##*/}" "${EXEC##*/}" "running" printf "%s: %s: %s" "${BASH_SOURCE[0]##*/}" "${EXEC##*/}" "running"
if [[ ! -z "$PIDFILE" ]]; then if [[ ! -z "$PIDFILE" ]]; then
if [[ ! -e "$PIDFILE" ]]; then if [[ ! -e "$PIDFILE" ]]; then
printf "%s" ", but .pid file does not exist" printf "%s" ", but .pid file does not exist"
elif ! grep "\<$(< "$PIDFILE")\>" <<<"$RUNPIDS" >/dev/null 2>&1; then elif ! grep "\<$(<"$PIDFILE")\>" <<<"$RUNPIDS" >/dev/null 2>&1; then
printf "%s" ", but .pid file is stale" printf "%s" ", but .pid file is stale"
fi fi
fi fi
printf "\\n" printf "\\n"
else else
printf "%s: %s: %s\\n" "${BASH_SOURCE##*/}" "${EXEC##*/}" "stopped" printf "%s: %s: %s\\n" "${BASH_SOURCE[0]##*/}" "${EXEC##*/}" "stopped"
return 1 return 1
fi fi
return 0 return 0
@ -50,30 +50,34 @@ checkstatus() {
startdaemon() { startdaemon() {
if [[ ! -e "$EXEC" ]]; then if [[ ! -e "$EXEC" ]]; then
error "not found" error "not found"
return 1 return 2
elif [[ ! -x "$EXEC" ]]; then elif [[ ! -x "$EXEC" ]]; then
error "not executable" error "not executable"
return 1 return 2
elif ! checkconfigured; then elif ! checkconfigured; then
error "not started - pre-start checks failed" error "not started - pre-start checks failed"
return 1 return 2
fi fi
${ENVIRONMENT:+declare ${ENVIRONMENT[*]};} "$EXEC" ${ARGS[*]} ${EXTRA_ARGS[*]} ${ENVIRONMENT:+declare ${ENVIRONMENT[*]};} "$EXEC" ${ARGS[*]} ${EXTRA_ARGS[*]}
if (( $? != 0 )); then if (( $? != 0 )); then
error "error starting daemon" error "error starting daemon"
return 1 return 2
else else
return 0 return 0
fi fi
} }
stopdaemon() { stopdaemon() {
[[ -e "$PIDFILE" ]] && kill -TERM "$(< "$PIDFILE")" >/dev/null 2>&1 || kill -TERM "$(pgrep -f "$EXEC" | tr $'\n' " ")" >/dev/null 2>&1 kill -TERM "$(pgrep -f "$EXEC" | tr $'\n' " ")" >/dev/null 2>&1
[[ -e "$PIDFILE" ]] && {
sleep 0.5
kill -TERM "$(<"$PIDFILE")" >/dev/null 2>&1
}
sleep "${SLAY_DELAY:-2}" sleep "${SLAY_DELAY:-2}"
if checkstatus >/dev/null; then checkstatus >/dev/null && {
error "failed to stop gracefully - slaying" error "failed to stop gracefully - slaying"
kill -KILL "$({ cat "$PIDFILE"; pgrep -f "$EXEC"; } 2>/dev/null | sort -u | tr $'\n' " ")" >/dev/null 2>&1 kill -KILL "$({ cat "$PIDFILE"; pgrep -f "$EXEC"; } 2>/dev/null | sort -u | tr $'\n' " ")" >/dev/null 2>&1
fi }
return 0 return 0
} }
@ -81,7 +85,7 @@ case "$1" in
'start') 'start')
if checkstatus >/dev/null; then if checkstatus >/dev/null; then
error "already running" error "already running"
printf " %s\\n" "Try: $BASH_SOURCE status" >&2 printf " %s\\n" "Try: ${BASH_SOURCE[0]} status" >&2
RET=1 RET=1
else else
startdaemon startdaemon
@ -91,7 +95,7 @@ case "$1" in
'stop') 'stop')
if ! checkstatus >/dev/null; then if ! checkstatus >/dev/null; then
error "not running" error "not running"
printf " %s\\n" "Try: $BASH_SOURCE status" >&2 printf " %s\\n" "Try: ${BASH_SOURCE[0]} status" >&2
RET=1 RET=1
else else
stopdaemon stopdaemon
@ -99,20 +103,20 @@ case "$1" in
fi fi
;; ;;
'restart') 'restart')
if checkstatus >/dev/null; then checkstatus >/dev/null
stopdaemon && sleep "${RESTART_DELAY:-2}" && startdaemon (( $? != 3 )) && {
RET=$? stopdaemon >/dev/null 2>&1
else sleep "${RESTART_DELAY:-2}"
}
startdaemon startdaemon
RET=$? RET=$?
fi
;; ;;
'status') 'status')
checkstatus checkstatus
RET=$? RET=$?
;; ;;
*) *)
printf "%s\\n" "Usage: $BASH_SOURCE <start|stop|restart|status>" >&2 printf "%s\\n" "Usage: ${BASH_SOURCE[0]} <start|stop|restart|status>" >&2
RET=1 RET=1
;; ;;
esac esac